{
  open Parser
}

let blank = [' ' '\009' '\012' '\010' '\013' ]
let lowercase = ['a'-'z' '\223'-'\246' '\248'-'\255' '_']
let uppercase = ['A'-'Z' '\192'-'\214' '\216'-'\222']
let identchar =
  ['A'-'Z' 'a'-'z' '_' '\192'-'\214' '\216'-'\246' '\248'-'\255' '\'' '0'-'9']


rule token = parse
  | blank+  { token lexbuf }
  | "_"     { UNDERSCORE }
  | "<"     { LANGLE }
  | ">"     { RANGLE }
  | "["     { LBRACKET }
  | "]"     { RBRACKET }
  | "("     { LPAREN }
  | ")"     { RPAREN }
  | "{"     { LBRACE }
  | "}"     { RBRACE }
  | "|"     { BAR }
  | ","     { COMMA }
  | "^"     { HAT }
  | "*"     { STAR }
  | "+"     { PLUS }
  | "="     { EQUAL }
  | "?"     { QUESTION }
  | "/"     { SLASH }
  | ":"     { COLON }
  | "->"    { ARROW }
  | "!"     { BANG }
  | (lowercase|uppercase) identchar* { IDENT (Lexing.lexeme lexbuf) }
  | "#check" { CHECK }
  | "#run"  { RUN }
  | "/*" { comment lexbuf }
  | eof { EOF }

and comment = parse
  | "*/" { token lexbuf }
  | _    { comment lexbuf }
