open Tags
open Syntax

let seq v1 v2 = match v1,v2 with 
  | Eps,v | v,Eps -> v
  | v1,v2 -> Seq (v1,v2)

let rec aux tag c = function
  | Elem (tag',e) -> 
      let t = 
	if SymbolSet.is_singleton tag' then tag' else SymbolSet.finite [tag] in
      Elem (t, aux tag c e)
  | Seq (e1,e2) -> seq (aux tag c e1) (aux tag c e2)
  | Eps -> Eps
  | Test (sset, t, e1, e2) ->
      let q = Regexp.compile t in
      if SymbolSet.has sset tag && State.match_forest q c
      then aux tag c e1 else aux tag c e2
  | Sub e ->
      run e c
  | Name s ->
      aux tag c (def s)
  | _ -> assert false

and run e = function
  | Seq (v1,v2) -> seq (run e v1) (run e v2)
  | Eps -> Eps
  | Elem (tag,v) -> aux (SymbolSet.sample tag) v e
  | Name s -> run e (def s)
  | _ -> assert false

let run e t = Expr.check e; Tree.check t; run e t
