open Tags
open Syntax

let rec check seen = function
  | Seq (e1,e2) -> check seen e1; check seen e2
  | Elem (t,c) ->
      if not (SymbolSet.is_singleton t) then
	failwith "Not a value";
      check seen c
  | Eps -> ()
  | Name x when List.mem x seen -> failwith "Not a value (cycle)"
  | Name x -> check (x::seen) (def x)
  | _ -> failwith "Not a value"

let check = check []

let rec get accu = function
  | Seq (e1,e2) -> get (get accu e2) e1
  | Elem (t,c) -> (SymbolSet.sample t, c) :: accu
  | Eps -> accu
  | _ -> assert false

let get = get []
  
